<script setup>
import PageTitle from "@/components/global/PageTitle.vue";
import RestrictedPageWrapper from "@/components/page/wrappers/RestrictedPageWrapper.vue";
import { SessionUser } from "@/components/session/token/SessionUser.vue";
import { useRouter } from 'vue-router'
import { ref } from 'vue';
import { ConfigurationSelectOption } from "@/components/displays/superuser/configuration/ConfigurationSelectObject.vue";
import ConfigurationSubPageWrapper
  from "@/views/dashboards/superUserDashboard/configuration/ConfigurationSubPageWrapper.vue";
import ConfigurationCategory from "@/components/displays/superuser/configuration/ConfigurationCategory.vue";
import ConfigurationSwitch from "@/components/displays/superuser/configuration/ConfigurationSwitch.vue";
import ConfigurationSelect from "@/components/displays/superuser/configuration/ConfigurationSelect.vue";
import ConfigurationSecretKey from "@/components/displays/superuser/configuration/ConfigurationSecretKey.vue";
import ConfigurationInput from "@/components/displays/superuser/configuration/ConfigurationInput.vue";
import ConfigurationInputNumber from "@/components/displays/superuser/configuration/ConfigurationInputNumber.vue";
import Swal from "sweetalert2";

// Get the department from the route
const router = useRouter()

const enabled = ref(false);
const module_config = ref([]);

const getEnabled = async () => {
  await SessionUser.superUser.modules.motorapi.config.enabled.get().then((response) => {
    console.log('MotorAPI enabled: ', response.data.data);
    enabled.value = response.data.data;
  }).catch((error) => {
    console.log(error);
  });
};

const getModuleConfig = async () => {
  await SessionUser.superUser.modules.motorapi.config.get_all().then((response) => {
    let tmp_module_config = response.data.data;
    let tmp_module_config_array = [];
    for (const [key, value] of Object.entries(tmp_module_config)) {
      console.log(`${value.variable}: ${value.value}`);
      tmp_module_config_array.push({
        variable: value.variable,
        value: value.value,
      });
    }
    module_config.value = tmp_module_config_array;
    console.log(module_config.value);
  }).catch((error) => {
    console.log(error);
  });
};

const getModuleConfigValue = (variable) => {
  const config = module_config.value.find((config) => config.variable === variable);
  // Log to the console, what the value was found
  if (config) {
    console.log(`Found value for ${variable}: ${config.value}`);
  } else {
    console.log(`No value found for ${variable}`);
  }
  return config ? config.value : '';
};

const load = async () => {
  await getModuleConfig();
};

load();

const showGetLicensePlate = () => {
  Swal.fire({
    title: 'Get license plate',
    input: 'text',
    inputAttributes: {
      autocapitalize: 'off'
    },
    showCancelButton: true,
    confirmButtonText: 'Get license plate',
    showLoaderOnConfirm: true,
    preConfirm: (license_plate) => {
      return SessionUser.superUser.modules.motorapi.functions.lookup(license_plate).then((response) => {
        console.log(response.data.data);
        return response.data.data;
      }).catch((error) => {
        console.log(error);
        Swal.showValidationMessage(
          `Request failed: ${error}`
        );
      });
    },
    allowOutsideClick: () => !Swal.isLoading()
  }).then((result) => {
    if (result.isConfirmed) {
      console.log(result);
      let html = '<div class="has-text-left">';
      for (const [key, value] of Object.entries(result.value)) {
        let value_parsed = value;
        // If the value is an object, then stringify it
        if (typeof value === 'object') {
          value_parsed = JSON.stringify(value);
        }
        html += `<div>
<span class="has-text-weight-bold">${key}:</span> ${value_parsed}
</div>`;
      }
      html += '</div>';
      Swal.fire({
        title: `License plate: ${result.value.license_plate}`,
        html: html,
      });
    }
  })
};
</script>

<template>
  <RestrictedPageWrapper :hasPermission="SessionUser.canAccessSuperUser()">
    <ConfigurationSubPageWrapper>
      <template #title>
        <PageTitle title="MotorAPI configuration" subtitle="The configuration of the MotorAPI integration" />
      </template>
      <template v-if="module_config.length > 0" #content>
        <ConfigurationCategory
          class="mt-2"
          module="MotorAPI"
          title="General settings"
          description="The general settings for the MotorAPI integration."
          icon="fas fa-cogs"
        >
        <ConfigurationSwitch
          class="mt-2"
          module="MotorAPI"
          title="Enable MotorAPI"
          description="Enable or disable the MotorAPI integration."
          icon="fas fa-cogs"
          :value="getModuleConfigValue('enabled') === true"
          :on-switch="SessionUser.superUser.modules.motorapi.config.enabled.set"
        />
        </ConfigurationCategory>
        <ConfigurationCategory
          class="mt-2"
          module="MotorAPI"
          title="API connection settings"
          description="The MotorAPI API connection settings."
          icon="fas fa-cogs"
        >
          <ConfigurationSecretKey
            class="mt-2"
            module="MotorAPI"
            title="Secret key (API key)"
            description="The secret key is used to authenticate the API connection."
            icon="fas fa-cogs"
            :isSet="getModuleConfigValue('secret_key') !== ''"
            :on-save="SessionUser.superUser.modules.motorapi.config.keys.secret_key.set"
          />
          <ConfigurationInputNumber
            class="mt-2"
            module="MotorAPI"
            title="Daily request limit"
            description="The daily request limit for the MotorAPI integration."
            icon="fas fa-cogs"
            :value="parseInt(getModuleConfigValue('daily_limit'))"
            :on-save="SessionUser.superUser.modules.motorapi.config.keys.daily_limit.set"
          />
        </ConfigurationCategory>
        <button class="button is-dark" @click="showGetLicensePlate">
          <span class="icon">
            <i class="fas fa-car"></i>
          </span>
          <span>Get license plate</span>
        </button>
      </template>
    </ConfigurationSubPageWrapper>
  </RestrictedPageWrapper>
</template>

<style scoped>

</style>